
unit GetPath;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtCtrls, FileCtrl, StdCtrls, Buttons, TypInfo, Grids;

type
  TFormGetPath = class(TForm)
    DirectoryListBox1: TDirectoryListBox;
    DriveComboBox1: TDriveComboBox;
    DirectoryName: TEdit;
    FileListBox1: TFileListBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    BBOK: TBitBtn;
    BBCancel: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure DirectoryNameKeyPress(Sender: TObject; var Key: Char);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure BBOKClick(Sender: TObject);
    procedure BBCancelClick(Sender: TObject);
  private
    { Private declarations }
    FCaption: String;
  public
    { Public declarations }
  end;

var
  FormGetPath: TFormGetPath;

implementation
{$R *.DFM}

procedure TFormGetPath.FormShow(Sender: TObject);
var
  S: String;
begin
  FCaption := '';
  S := TForm(Sender).Caption;
  if FileExists(S) then
     DirectoryName.Text := ExtractFileDir(S)
  else
     DirectoryName.Text := '';
  TForm(Sender).Caption:= 'ؿ]w';
  if DirectoryName.Text= '' then
     DirectoryListBox1.OpenCurrent
  else
     DirectoryListBox1.Directory := DirectoryName.Text;
end;

procedure TFormGetPath.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  TForm(Sender).Caption := FCaption;
  Action := caFree;
end;

procedure TFormGetPath.DirectoryNameKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then begin
     FileListBox1.ApplyFilePath(DirectoryName.Text);
     Key := #0;
  end;
end;

procedure TFormGetPath.DirectoryListBox1Change(Sender: TObject);
begin
  DirectoryName.Text := DirectoryListBox1.Directory;
end;

procedure TFormGetPath.BBOKClick(Sender: TObject);
begin
  if (DirectoryName.Text <> '') and (not DirectoryExists(DirectoryName.Text)) then
     if MessageDlg('ؿsbAO_إߡH',mtConfirmation, [mbYes, mbNo], 0) = mrYes then
        if not CreateDir(DirectoryName.Text) then
           begin
             ShowMessage('ؿLkإߡI');
             Exit;
           end;
  FCaption := FileListBox1.FileName;
  Close;
end;

procedure TFormGetPath.BBCancelClick(Sender: TObject);
begin
  FCaption := '';
  Close;
end;


end.
