unit MainTransfer;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ToolWin, OleCtnrs, ShellAPI, Buttons, Registry,
  ExtCtrls, ImgList, Menus, Grids, DBGrids, DB, ADODB, AppEvnts;

type
  TFormMainTransfer = class(TForm)
    GBGroup: TGroupBox;
    PanelTop: TPanel;
    GBSplitter: TGroupBox;
    ImageList0: TImageList;
    ToolBar1: TToolBar;
    ToolBar2: TToolBar;
    ToolBar3: TToolBar;
    SBZ: TSpeedButton;
    SBY: TSpeedButton;
    SBX: TSpeedButton;
    SBW: TSpeedButton;
    SBV: TSpeedButton;
    SBU: TSpeedButton;
    SBT: TSpeedButton;
    SBS: TSpeedButton;
    SBR: TSpeedButton;
    SBQ: TSpeedButton;
    SBP: TSpeedButton;
    SBO: TSpeedButton;
    SBN: TSpeedButton;
    SBM: TSpeedButton;
    SBL: TSpeedButton;
    SBK: TSpeedButton;
    SBJ: TSpeedButton;
    SBI: TSpeedButton;
    SBH: TSpeedButton;
    SBG: TSpeedButton;
    SBF: TSpeedButton;
    SBE: TSpeedButton;
    SBD: TSpeedButton;
    SBC: TSpeedButton;
    SBB: TSpeedButton;
    SBA: TSpeedButton;
    BBA: TBitBtn;
    BBB: TBitBtn;
    BBC: TBitBtn;
    BBD: TBitBtn;
    BBE: TBitBtn;
    BBF: TBitBtn;
    BBG: TBitBtn;
    BBH: TBitBtn;
    BBI: TBitBtn;
    BBJ: TBitBtn;
    BBK: TBitBtn;
    BBL: TBitBtn;
    BBM: TBitBtn;
    BBClose: TBitBtn;
    BBN: TBitBtn;
    BBO: TBitBtn;
    BBP: TBitBtn;
    BBQ: TBitBtn;
    BBR: TBitBtn;
    BBS: TBitBtn;
    BBT: TBitBtn;
    BBU: TBitBtn;
    BBV: TBitBtn;
    BBW: TBitBtn;
    BBX: TBitBtn;
    BBY: TBitBtn;
    BBZ: TBitBtn;
    SB0: TSpeedButton;
    SBRun: TSpeedButton;
    SBTile: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SB0Click(Sender: TObject);
    procedure BBAClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SBTileClick(Sender: TObject);
    procedure SBRunClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
    RKey: String;
    ArrayHWND: array[1..26] of HWND;
    AutoFormName: String;
    procedure ChangeBitmap(Flag: Integer; Sender: TObject);
  public
    { Public declarations }
  end;

var
  FormMainTransfer: TFormMainTransfer;

implementation
uses LinkFile,ClassAuto;

{$R *.dfm}

procedure TFormMainTransfer.ChangeBitmap(Flag: Integer; Sender: TObject);
var
  B: TBitmap;
begin
  B := TBitmap.Create;
  ImageList0.GetBitmap(Flag,B);
  try
    TSpeedButton(Sender).Glyph := B;
  finally
    B.Free;
  end;
end;

procedure TFormMainTransfer.FormCreate(Sender: TObject);
var
  I: Integer;
  Reg: TRegistry;
begin
  RKey := 'AutoTransfer';
  AutoFormName := 'TFormAuto';
  for I := Low(ArrayHWND) to High(ArrayHWND) do ArrayHWND[I] := 0;
  //
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CURRENT_USER;
    if not Reg.KeyExists(RKey) then
    with TFormLinkFile.Create(Self) do
    try
      ShowModal;
    finally
      Free;
    end;
  finally
    for I := 1 to 26 do begin
        Reg.OpenKeyReadOnly(RKey+'\'+Chr(64+I));
        TBitBtn(FindComponent('BB'+Chr(64+I))).Caption   := Reg.ReadString('Title');
        TBitBtn(FindComponent('BB'+Chr(64+I))).Enabled   := Reg.ReadString('Title') <> '';
        TSpeedButton(FindComponent('SB'+Chr(64+I))).Hint := Reg.ReadString('Title');
        Reg.CloseKey;
    end;
    Reg.Free;
  end;
  //
  with ToolBar2 do
  for I := 0 to ControlCount-1 do
      if Controls[I] is TSpeedButton then ChangeBitmap(1,TSpeedButton(Controls[I]));
end;

procedure TFormMainTransfer.FormShow(Sender: TObject);
begin
  //
end;

procedure TFormMainTransfer.FormClose(Sender: TObject;
  var Action: TCloseAction);
var
  N: String;
begin
  if Pos(AutoFormName,TForm(Sender).Name) = 0 then Exit;
  N := TForm(Sender).Name;
  N := N[Length(N)];
  ChangeBitmap(1,TSpeedButton(FindComponent('SB'+N)));
  ArrayHWND[TForm(Sender).Tag] := 0;
  Action := caFree;
end;

procedure TFormMainTransfer.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (ssCtrl in Shift) and ((Chr(Key)) in ['A'..'Z']) then
      BBAClick(TBitBtn(FindComponent('BB'+UpperCase(Char(Key)))));
  if (ssCtrl in Shift) and (Key = VK_F10) then
  with TFormLinkFile.Create(Self) do
  try
    ShowModal;
  finally
    Free;
  end;
end;

procedure TFormMainTransfer.SB0Click(Sender: TObject);
begin
  if SB0.Caption = 'Hide' then
     begin
       SB0.Caption := 'Show';
       GBGroup.Visible := False;
     end
  else
     begin
       SB0.Caption := 'Hide';
       GBGroup.Visible := True;
     end;
  SBTileClick(Nil);
end;


procedure TFormMainTransfer.BBAClick(Sender: TObject);
var
  F: TForm;
  S: String;
  L: TStringList;
  FC: TFormClass;
begin
  //
  S := AutoFormName+CHR(64+TBitBtn(Sender).Tag);
  FC := TFormClass(GetClass(S));
  if FC = Nil then begin
     ShowMessage('{|إߡI');
     Exit;
  end;
  // P_O_椤
  if TForm(FindComponent(S)) <> Nil then
     Exit
  else
     F := FC.Create(Self);
  S := AutoFormName+CHR(64+TBitBtn(Sender).Tag);
  //if FindComponent(S) <> Nil then begin TForm(FindComponent(S)).Show ;Exit; end;
  //
  //WriteComponentResFile('Temp.dfm', FormAuto);
  //F := TFormAuto.CreateNew(Application);
  L := TStringList.Create;
  L.Add(S);
  try
    with F do begin
      //ReadComponentResFile('Temp.dfm', F);
      Tag := TBitBtn(Sender).Tag;
      ArrayHWND[Tag] := Handle;
      Name := S;
      Caption := L.Text;
      OnClose := FormMainTransfer.OnClose;
      Windows.SetParent(Handle,GBSplitter.Handle);
      TListBox(FindComponent('ListBox0')).AddItem(S,TForm(FindComponent(S)));
      Show;
    end;
  finally
    L.Free;
  end;
  // 󴫹 OwG
  ChangeBitmap(0,TSpeedButton(FindComponent('SB'+S[Length(S)])));
  // TileWindow
  SBTileClick(Nil);
end;

procedure TFormMainTransfer.SBTileClick(Sender: TObject);
begin
  TileWindows(FormMainTransfer.GBSplitter.Handle,MDITILE_VERTICAL,nil,0,nil);
end;

procedure TFormMainTransfer.SBRunClick(Sender: TObject);
var
  S: String;
  I: Integer;
begin
  for I := Low(ArrayHWND) to High(ArrayHWND) do begin
      Application.ProcessMessages;
      if ArrayHWND[I] = 0 then Continue;
      S := AutoFormName+CHR(64+I);
      if FindComponent(S) <> Nil then
      with TForm(FindComponent(S)) do begin
         TTimer(FindComponent('Timer0')).Enabled := True;
         TPanel(FindComponent('Panel0')).Caption := TListBox(FindComponent('ListBox0')).Items[0];
      end;
  end;
end;

procedure TFormMainTransfer.FormResize(Sender: TObject);
begin
  SBTileClick(Nil);
end;

end.
